classification
Title: Feature Request CAN_RAW_FD_FRAMES
Type: enhancement Stage: resolved
Components: Library (Lib) Versions: Python 3.5
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: larry Nosy List: benjamin.peterson, berker.peksag, doko, larry, llllllllll, neologix, pitrou, python-dev, r.david.murray, rumpelsepp
Priority: normal Keywords: patch

Created on 2014-10-14 14:21 by rumpelsepp, last changed 2015-04-14 18:10 by r.david.murray. This issue is now closed.

Files
File name Uploaded Description Edit
CAN_RAW_FD_FRAMES.patch llllllllll, 2015-04-13 17:02 review
CAN_RAW_FD_FRAMES-update.patch llllllllll, 2015-04-13 19:50 review
CAN_RAW_FD_FRAMES-doc.patch llllllllll, 2015-04-13 20:30 review
Messages (17)
msg229289 - (view) Author: Stefan Tatschner (rumpelsepp) * Date: 2014-10-14 14:21
CAN support was introduced with issue #10141. Python still seems to lack support for CAN FD which is available with the socket option CAN_RAW_FD_FRAMES, see here (chapter 4.1.5): https://www.kernel.org/doc/Documentation/networking/can.txt
msg229339 - (view) Author: Charles-François Natali (neologix) * (Python committer) Date: 2014-10-14 19:41
Annoying.
I thought CAN_RAW_FD_FRAME would be a macro, which would have made conditional compilation easy, but it's apparently a enum value, which means we have to add a configure-time check...
msg240662 - (view) Author: Joe Jevnik (llllllllll) * Date: 2015-04-13 17:02
I have added a patch to update this with conditional compilation.
msg240663 - (view) Author: Joe Jevnik (llllllllll) * Date: 2015-04-13 17:08
To show where I got my sources: https://github.com/torvalds/linux/commit/e2d265d3b587f5f6f8febc0222aace93302ff0be

There does not appear to be any new structures needed other than supporting the constant.
msg240680 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2015-04-13 17:41
LGTM, just adding Antoine (the expert for the socket module).  I'm ready to commit over here.
msg240709 - (view) Author: Berker Peksag (berker.peksag) * (Python committer) Date: 2015-04-13 19:19
The new constant should probably be added to https://docs.python.org/3/library/socket.html#constants (with a .. versionadded:: 3.5 directive)
msg240716 - (view) Author: Joe Jevnik (llllllllll) * Date: 2015-04-13 19:50
I am not going to be able to write docs on this because I am not totally sure how you would use this; There is an entry in the docs for CAN_* so that might be enough. I have a line now saying that this particular flag is available as of 3.5 though.
msg240723 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2015-04-13 20:03
Follow the instructions in this:

https://docs.python.org/devguide/docquality.html

And make it look something like this:

https://docs.python.org/3/library/socket.html#socket.CAN_BCM
msg240736 - (view) Author: Joe Jevnik (llllllllll) * Date: 2015-04-13 20:30
I tried to provide a summary of the Linux page on the topic and then said that it was fully documented there.
msg240773 - (view) Author: Roundup Robot (python-dev) Date: 2015-04-13 21:49
New changeset 03ff92b26fa9 by Larry Hastings in branch 'default':
Issue #22631: Added Linux-specific socket constant CAN_RAW_FD_FRAMES.
https://hg.python.org/cpython/rev/03ff92b26fa9
msg240774 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2015-04-13 21:49
Patch committed. Thanks, Joe!
msg240799 - (view) Author: Matthias Klose (doko) * (Python committer) Date: 2015-04-13 23:02
it would be nice to have these constants backported to both 2.7 and 3.4. It may be good to check for other missing consgtants in this module in 2.7 and 3.4.
msg240841 - (view) Author: Joe Jevnik (llllllllll) * Date: 2015-04-14 05:08
So I think the patch could be applied to 3.4; I will look into moving the other back sometime this week.
msg240957 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2015-04-14 17:07
Isn't this a "new feature"?  2.7 is maybe fair game, but 3.4 arguably is not.

It should be odd to have a field marked in the documentation as "New in 3.4.4."
msg240958 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2015-04-14 17:08
It is a new feature.
msg240959 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2015-04-14 17:09
Benjamin, would you like CAN_RAW_FD_FRAMES in the next 2.7?
msg240969 - (view) Author: R. David Murray (r.david.murray) * (Python committer) Date: 2015-04-14 18:10
There is no CAN support in 2.7, so no.
History
Date User Action Args
2015-04-14 18:10:37r.david.murraysetnosy: + r.david.murray
messages: + msg240969
2015-04-14 17:09:39larrysetnosy: + benjamin.peterson
messages: + msg240959
2015-04-14 17:08:29pitrousetmessages: + msg240958
2015-04-14 17:07:43larrysetmessages: + msg240957
2015-04-14 05:08:04llllllllllsetmessages: + msg240841
2015-04-13 23:02:10dokosetnosy: + doko
messages: + msg240799
2015-04-13 21:49:43larrysetstatus: open -> closed
messages: + msg240774

assignee: larry
resolution: fixed
stage: commit review -> resolved
2015-04-13 21:49:01python-devsetnosy: + python-dev
messages: + msg240773
2015-04-13 20:30:10llllllllllsetfiles: + CAN_RAW_FD_FRAMES-doc.patch

messages: + msg240736
2015-04-13 20:03:07larrysetmessages: + msg240723
2015-04-13 19:50:18llllllllllsetfiles: + CAN_RAW_FD_FRAMES-update.patch

messages: + msg240716
2015-04-13 19:19:01berker.peksagsetnosy: + berker.peksag

messages: + msg240709
stage: commit review
2015-04-13 17:41:40larrysetnosy: + pitrou
messages: + msg240680
2015-04-13 17:08:16llllllllllsetnosy: + larry
messages: + msg240663
2015-04-13 17:02:05llllllllllsetfiles: + CAN_RAW_FD_FRAMES.patch

nosy: + llllllllll
messages: + msg240662

keywords: + patch
2014-10-15 08:31:17rumpelseppsettitle: Feature Request CAN_RAW_FD_FRAME -> Feature Request CAN_RAW_FD_FRAMES
2014-10-14 19:41:43neologixsetmessages: + msg229339
components: + Library (Lib), - IO
2014-10-14 19:01:43ned.deilysetnosy: + neologix
2014-10-14 14:21:28rumpelseppcreate